Index: modules/TimeSmearing.h
===================================================================
--- modules/TimeSmearing.h	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/TimeSmearing.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -22,7 +22,7 @@
 /** \class TimeSmearing
  *
- *  Performs transverse time smearing.
+ *  Performs time smearing.
  *
- *  \author Michele Selvaggi - UCL, Louvain-la-Neuve
+ *  \author Michele Selvaggi - CERN
  *
  */
@@ -32,4 +32,5 @@
 class TIterator;
 class TObjArray;
+class DelphesFormula;
 
 class TimeSmearing: public DelphesModule
@@ -44,5 +45,7 @@
 
 private:
-  Double_t fTimeResolution;
+
+  DelphesFormula *fResolutionFormula;
+  Int_t fVertexTimeMode;
 
   TIterator *fItInputArray; //!
Index: modules/TrackCovariance.cc
===================================================================
--- modules/TrackCovariance.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/TrackCovariance.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,188 @@
+  /*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2020  Universite catholique de Louvain (UCLouvain), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** \class TrackCovariance
+ *
+ *  Smears track parameters according to appropriate covariance matrix.
+ *
+ *  \authors F. Bedeschi - INFN Pisa
+*            P. Demin - UCLouvain, Louvain-la-Neuve
+ *           M. Selvaggi - CERN
+ *
+ *
+ */
+
+//FIXME add reference to Bedeschi-code
+//FIXME make sure about units of P, X
+//FIXME fix pt > 200 GeV issue and angle > 6.41
+
+#include "modules/TrackCovariance.h"
+
+#include "classes/DelphesClasses.h"
+
+#include "TrackCovariance/SolGeom.h"
+#include "TrackCovariance/SolGridCov.h"
+#include "TrackCovariance/ObsTrk.h"
+
+#include "TLorentzVector.h"
+#include "TMath.h"
+#include "TObjArray.h"
+
+#include <iostream>
+#include <sstream>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+
+TrackCovariance::TrackCovariance() :
+  fGeometry(0), fCovariance(0), fAcx(0), fItInputArray(0)
+{
+  fGeometry = new SolGeom();
+  fCovariance = new SolGridCov();
+}
+
+//------------------------------------------------------------------------------
+
+TrackCovariance::~TrackCovariance()
+{
+  if(fGeometry) delete fGeometry;
+  if(fCovariance) delete fCovariance;
+}
+
+//------------------------------------------------------------------------------
+
+void TrackCovariance::Init()
+{
+  fBz = GetDouble("Bz", 0.0);
+  fGeometry->Read(GetString("DetectorGeometry", ""));
+  fNMinHits = GetInt("NMinHits", 6);
+
+  // load geometry
+  fCovariance->Calc(fGeometry);
+  fCovariance->SetMinHits(fNMinHits);
+  // load geometry
+  fAcx = fCovariance->AccPnt();
+
+  // import input array
+  fInputArray = ImportArray(GetString("InputArray", "TrackMerger/tracks"));
+  fItInputArray = fInputArray->MakeIterator();
+
+  // create output array
+
+  fOutputArray = ExportArray(GetString("OutputArray", "tracks"));
+}
+
+//------------------------------------------------------------------------------
+
+void TrackCovariance::Finish()
+{
+  if(fItInputArray) delete fItInputArray;
+}
+
+//------------------------------------------------------------------------------
+
+void TrackCovariance::Process()
+{
+  Candidate *candidate, *mother, *particle;
+  Double_t mass, p, pt, q, ct;
+  Double_t dd0, ddz, dphi, dct, dp, dpt, dC;
+  //
+  // Get cylindrical box for fast track simulation
+  //
+  Double_t Rin = fGeometry->GetRmin();
+  Double_t ZinPos = fGeometry->GetZminPos();
+  Double_t ZinNeg = fGeometry->GetZminNeg();
+
+  fItInputArray->Reset();
+  while((candidate = static_cast<Candidate *>(fItInputArray->Next())))
+  {
+
+    // converting to meters
+    particle = static_cast<Candidate *>(candidate->GetCandidates()->At(0));
+
+    // converting to meters
+    const TLorentzVector &candidatePosition = particle->Position*1e-03;
+    const TLorentzVector &candidateMomentum = particle->Momentum;
+
+    Bool_t inside = TrkUtil::IsInside(candidatePosition.Vect(), Rin, ZinNeg, ZinPos); // Check if in inner box
+    Bool_t Accept = kTRUE;
+    if(inside) Accept = fCovariance->IsAccepted(candidateMomentum.Vect());
+    else       Accept = fCovariance->IsAccepted(candidatePosition.Vect(),candidateMomentum.Vect(), fGeometry);
+    if(!Accept) continue;
+
+    mass = candidateMomentum.M();
+
+    ObsTrk track(candidatePosition.Vect(), candidateMomentum.Vect(), candidate->Charge, fCovariance, fGeometry);
+
+    mother    = candidate;
+    candidate = static_cast<Candidate*>(candidate->Clone());
+
+    candidate->Momentum.SetVectM(track.GetObsP(), mass);
+
+    // converting back to mm
+    candidate->InitialPosition.SetXYZT(track.GetObsX().X()*1e03,track.GetObsX().Y()*1e03,track.GetObsX().Z()*1e03,candidatePosition.T()*1e03);
+
+    // save full covariance 5x5 matrix internally (D0, phi, Curvature, dz, ctg(theta))
+    candidate->TrackCovariance = track.GetCov();
+
+    pt = candidate->Momentum.Pt();
+    p  = candidate->Momentum.P();
+    q  = track.GetObsQ();
+    ct = track.GetObsPar()[4];
+
+    candidate->Xd = track.GetObsX().X()*1e03;
+    candidate->Yd = track.GetObsX().Y()*1e03;
+    candidate->Zd = track.GetObsX().Z()*1e03;
+
+    candidate->D0       = track.GetObsPar()[0]*1e03;
+    candidate->Phi      = track.GetObsPar()[1];
+
+    // inverse of curvature
+    candidate->C        = track.GetObsPar()[2]*1e-03;
+    candidate->DZ       = track.GetObsPar()[3]*1e03;
+    candidate->CtgTheta = track.GetObsPar()[4];
+    candidate->P        = track.GetObsP().Mag();
+    candidate->PT       = pt;
+    candidate->Charge   = q;
+
+    dd0       = TMath::Sqrt(track.GetCov()(0, 0))*1e03;
+    ddz       = TMath::Sqrt(track.GetCov()(3, 3))*1e03;
+    dphi      = TMath::Sqrt(track.GetCov()(1, 1));
+    dct       = TMath::Sqrt(track.GetCov()(4, 4));
+    dpt       = 2 * TMath::Sqrt( track.GetCov()(2, 2))*pt*pt / (0.2998*fBz);
+    dp        = TMath::Sqrt((1.+ct*ct)*dpt*dpt + 4*pt*pt*ct*ct*dct*dct/(1.+ct*ct)/(1.+ct*ct));
+    dC        = TMath::Sqrt(track.GetCov()(2, 2))*1e-03;
+
+    candidate->ErrorD0 = dd0;
+    candidate->ErrorDZ = ddz;
+    candidate->ErrorP = dp;
+    candidate->ErrorC = dC;
+    candidate->ErrorCtgTheta = dct;
+    candidate->ErrorPhi = dphi;
+    candidate->ErrorPT = dpt;
+    //candidate->TrackResolution = dpt / pt;
+    candidate->TrackResolution = dp / p;
+
+    candidate->AddCandidate(mother);
+
+    fOutputArray->Add(candidate);
+  }
+}
+
+//------------------------------------------------------------------------------
Index: modules/TrackCovariance.h
===================================================================
--- modules/TrackCovariance.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/TrackCovariance.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,68 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2020  Universite catholique de Louvain (UCLouvain), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef TrackCovariance_h
+#define TrackCovariance_h
+
+/** \class TrackCovariance
+ *
+ *  Smears track parameters according to appropriate covariance matrix.
+ *
+ *  \authors P. Demin - UCLouvain, Louvain-la-Neuve
+ *           M. Selvaggi - CERN
+ *
+ */
+
+#include "classes/DelphesModule.h"
+
+class TIterator;
+class TObjArray;
+
+class SolGeom;
+class SolGridCov;
+class AcceptanceClx;
+
+class TrackCovariance: public DelphesModule
+{
+public:
+  TrackCovariance();
+  ~TrackCovariance();
+
+  void Init();
+  void Process();
+  void Finish();
+
+private:
+  Double_t fBz;
+  Int_t fNMinHits;
+
+  SolGeom *fGeometry;
+  SolGridCov *fCovariance;
+
+  AcceptanceClx *fAcx;
+
+  TIterator *fItInputArray; //!
+
+  const TObjArray *fInputArray; //!
+
+  TObjArray *fOutputArray; //!
+
+  ClassDef(TrackCovariance, 1)
+};
+
+#endif
Index: modules/TrackSmearing.cc
===================================================================
--- modules/TrackSmearing.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/TrackSmearing.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -158,5 +158,5 @@
   TLorentzVector beamSpotPosition;
   Candidate *candidate, *mother;
-  Double_t pt, eta, d0, d0Error, trueD0, dz, dzError, trueDZ, p, pError, trueP, ctgTheta, ctgThetaError, trueCtgTheta, phi, phiError, truePhi;
+  Double_t pt, eta, e, m, d0, d0Error, trueD0, dz, dzError, trueDZ, p, pError, trueP, ctgTheta, ctgThetaError, trueCtgTheta, phi, phiError, truePhi;
   Double_t x, y, z, t, px, py, pz, theta;
   Double_t q, r;
@@ -223,4 +223,6 @@
     pt = momentum.Pt();
     eta = momentum.Eta();
+    e = momentum.E();
+    m = momentum.M();
 
     d0 = trueD0 = candidate->D0;
@@ -232,5 +234,5 @@
 
     if(fUseD0Formula)
-      d0Error = fD0Formula->Eval(pt, eta);
+      d0Error = fD0Formula->Eval(pt, eta, phi, e, candidate);
     else
     {
@@ -247,5 +249,5 @@
 
     if(fUseDZFormula)
-      dzError = fDZFormula->Eval(pt, eta);
+      dzError = fDZFormula->Eval(pt, eta, phi, e, candidate);
     else
     {
@@ -262,5 +264,5 @@
 
     if(fUsePFormula)
-      pError = fPFormula->Eval(pt, eta) * p;
+      pError = fPFormula->Eval(pt, eta, phi, e, candidate) * p;
     else
     {
@@ -277,5 +279,5 @@
 
     if(fUseCtgThetaFormula)
-      ctgThetaError = fCtgThetaFormula->Eval(pt, eta);
+      ctgThetaError = fCtgThetaFormula->Eval(pt, eta, phi, e, candidate);
     else
     {
@@ -292,5 +294,5 @@
 
     if(fUsePhiFormula)
-      phiError = fPhiFormula->Eval(pt, eta);
+      phiError = fPhiFormula->Eval(pt, eta, phi, e, candidate);
     else
     {
@@ -331,5 +333,5 @@
     candidate->Momentum.SetPy(p * TMath::Sin(phi) * TMath::Sin(theta));
     candidate->Momentum.SetPz(p * TMath::Cos(theta));
-    candidate->Momentum.SetE(candidate->Momentum.Pt() * TMath::CosH(eta));
+    candidate->Momentum.SetE(TMath::Sqrt(p*p + m*m));
     candidate->PT = candidate->Momentum.Pt();
 
Index: modules/TreeWriter.cc
===================================================================
--- modules/TreeWriter.cc	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/TreeWriter.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -72,4 +72,5 @@
   fClassMap[Track::Class()] = &TreeWriter::ProcessTracks;
   fClassMap[Tower::Class()] = &TreeWriter::ProcessTowers;
+  fClassMap[ParticleFlowCandidate::Class()] = &TreeWriter::ProcessParticleFlowCandidates;
   fClassMap[Photon::Class()] = &TreeWriter::ProcessPhotons;
   fClassMap[Electron::Class()] = &TreeWriter::ProcessElectrons;
@@ -123,4 +124,17 @@
     fBranchMap.insert(make_pair(branch, make_pair(itClassMap->second, array)));
   }
+
+  param = GetParam("Info");
+  TString infoName;
+  Double_t infoValue;
+
+  size = param.GetSize();
+  for(i = 0; i < size / 2; ++i)
+  {
+    infoName = param[i * 2].GetString();
+    infoValue = param[i * 2 + 1].GetDouble();
+
+    AddInfo(infoName, infoValue);
+  }
 }
 
@@ -138,4 +152,5 @@
   it1.Reset();
   array->Clear();
+
   while((candidate = static_cast<Candidate *>(it1.Next())))
   {
@@ -215,11 +230,4 @@
     entry->Pz = momentum.Pz();
 
-    entry->D0 = candidate->D0;
-    entry->DZ = candidate->DZ;
-    entry->P = momentum.P();
-    entry->PT = candidate->PT;
-    entry->CtgTheta = candidate->CtgTheta;
-    entry->Phi = candidate->Phi;
-
     entry->Eta = eta;
     entry->Phi = momentum.Phi();
@@ -322,5 +330,5 @@
   Candidate *particle = 0;
   Track *entry = 0;
-  Double_t pt, signz, cosTheta, eta, rapidity, p, ctgTheta, phi;
+  Double_t pt, signz, cosTheta, eta, rapidity, p, ctgTheta, phi, m;
   const Double_t c_light = 2.99792458E8;
 
@@ -356,12 +364,29 @@
 
     entry->D0 = candidate->D0;
-    entry->ErrorD0 = candidate->ErrorD0;
     entry->DZ = candidate->DZ;
-    entry->ErrorDZ = candidate->ErrorDZ;
+    entry->Nclusters = candidate->Nclusters;
+    entry->dNdx = candidate->dNdx;
 
     entry->ErrorP = candidate->ErrorP;
     entry->ErrorPT = candidate->ErrorPT;
+
+    // diagonal covariance matrix terms
+    entry->ErrorD0 = candidate->ErrorD0;
+    entry->ErrorC = candidate->ErrorC;
+    entry->ErrorPhi = candidate->ErrorPhi;
+    entry->ErrorDZ = candidate->ErrorDZ;
     entry->ErrorCtgTheta = candidate->ErrorCtgTheta;
-    entry->ErrorPhi = candidate->ErrorPhi;
+
+    // add some offdiagonal covariance matrix elements
+    entry->ErrorD0Phi          = candidate->TrackCovariance(0,1);
+    entry->ErrorD0C            = candidate->TrackCovariance(0,2);
+    entry->ErrorD0DZ           = candidate->TrackCovariance(0,3);
+    entry->ErrorD0CtgTheta     = candidate->TrackCovariance(0,4);
+    entry->ErrorPhiC           = candidate->TrackCovariance(1,2);
+    entry->ErrorPhiDZ          = candidate->TrackCovariance(1,3);
+    entry->ErrorPhiCtgTheta    = candidate->TrackCovariance(1,4);
+    entry->ErrorCDZ            = candidate->TrackCovariance(2,3);
+    entry->ErrorCCtgTheta      = candidate->TrackCovariance(2,4);
+    entry->ErrorDZCtgTheta     = candidate->TrackCovariance(3,4);
 
     entry->Xd = candidate->Xd;
@@ -374,4 +399,5 @@
     p = momentum.P();
     phi = momentum.Phi();
+    m = momentum.M();
     ctgTheta = (TMath::Tan(momentum.Theta()) != 0) ? 1 / TMath::Tan(momentum.Theta()) : 1e10;
 
@@ -386,7 +412,10 @@
     entry->Phi = phi;
     entry->CtgTheta = ctgTheta;
+    entry->C = candidate->C;
+    entry->Mass = m;
 
     particle = static_cast<Candidate *>(candidate->GetCandidates()->At(0));
-    const TLorentzVector &initialPosition = particle->Position;
+    //const TLorentzVector &initialPosition = particle->Position;
+    const TLorentzVector &initialPosition = candidate->InitialPosition;
 
     entry->X = initialPosition.X();
@@ -394,4 +423,5 @@
     entry->Z = initialPosition.Z();
     entry->T = initialPosition.T() * 1.0E-3 / c_light;
+    entry->ErrorT =candidate-> ErrorT * 1.0E-3 / c_light;
 
     entry->Particle = particle;
@@ -435,4 +465,5 @@
     entry->Eem = candidate->Eem;
     entry->Ehad = candidate->Ehad;
+    entry->Etrk = candidate->Etrk;
     entry->Edges[0] = candidate->Edges[0];
     entry->Edges[1] = candidate->Edges[1];
@@ -444,4 +475,126 @@
 
     FillParticles(candidate, &entry->Particles);
+  }
+}
+
+//------------------------------------------------------------------------------
+
+void TreeWriter::ProcessParticleFlowCandidates(ExRootTreeBranch *branch, TObjArray *array)
+{
+
+  TIter iterator(array);
+  Candidate *candidate = 0;
+  Candidate *particle = 0;
+  ParticleFlowCandidate *entry = 0;
+  Double_t e, pt, signz, cosTheta, eta, rapidity, p, ctgTheta, phi, m;
+  const Double_t c_light = 2.99792458E8;
+
+  // loop over all tracks
+  iterator.Reset();
+  while((candidate = static_cast<Candidate *>(iterator.Next())))
+  {
+    const TLorentzVector &position = candidate->Position;
+
+    cosTheta = TMath::Abs(position.CosTheta());
+    signz = (position.Pz() >= 0.0) ? 1.0 : -1.0;
+    eta = (cosTheta == 1.0 ? signz * 999.9 : position.Eta());
+    rapidity = (cosTheta == 1.0 ? signz * 999.9 : position.Rapidity());
+
+    entry = static_cast<ParticleFlowCandidate *>(branch->NewEntry());
+
+    entry->SetBit(kIsReferenced);
+    entry->SetUniqueID(candidate->GetUniqueID());
+
+    entry->PID = candidate->PID;
+
+    entry->Charge = candidate->Charge;
+
+    entry->EtaOuter = eta;
+    entry->PhiOuter = position.Phi();
+
+    entry->XOuter = position.X();
+    entry->YOuter = position.Y();
+    entry->ZOuter = position.Z();
+    entry->TOuter = position.T() * 1.0E-3 / c_light;
+
+    entry->L = candidate->L;
+
+    entry->D0 = candidate->D0;
+    entry->DZ = candidate->DZ;
+    entry->Nclusters = candidate->Nclusters;
+    entry->dNdx = candidate->dNdx;
+
+    entry->ErrorP = candidate->ErrorP;
+    entry->ErrorPT = candidate->ErrorPT;
+    entry->ErrorCtgTheta = candidate->ErrorCtgTheta;
+
+
+    // diagonal covariance matrix terms
+
+    entry->ErrorD0 = candidate->ErrorD0;
+    entry->ErrorC = candidate->ErrorC;
+    entry->ErrorPhi = candidate->ErrorPhi;
+    entry->ErrorDZ = candidate->ErrorDZ;
+    entry->ErrorCtgTheta = candidate->ErrorCtgTheta;
+
+    // add some offdiagonal covariance matrix elements
+    entry->ErrorD0Phi          = candidate->TrackCovariance(0,1);
+    entry->ErrorD0C            = candidate->TrackCovariance(0,2);
+    entry->ErrorD0DZ           = candidate->TrackCovariance(0,3);
+    entry->ErrorD0CtgTheta     = candidate->TrackCovariance(0,4);
+    entry->ErrorPhiC           = candidate->TrackCovariance(1,2);
+    entry->ErrorPhiDZ          = candidate->TrackCovariance(1,3);
+    entry->ErrorPhiCtgTheta    = candidate->TrackCovariance(1,4);
+    entry->ErrorCDZ            = candidate->TrackCovariance(2,3);
+    entry->ErrorCCtgTheta      = candidate->TrackCovariance(2,4);
+    entry->ErrorDZCtgTheta     = candidate->TrackCovariance(3,4);
+
+    entry->Xd = candidate->Xd;
+    entry->Yd = candidate->Yd;
+    entry->Zd = candidate->Zd;
+
+    const TLorentzVector &momentum = candidate->Momentum;
+
+    e = momentum.E();
+    pt = momentum.Pt();
+    p = momentum.P();
+    phi = momentum.Phi();
+    m = momentum.M();
+    ctgTheta = (TMath::Tan(momentum.Theta()) != 0) ? 1 / TMath::Tan(momentum.Theta()) : 1e10;
+
+    entry->E = e;
+    entry->P = p;
+    entry->PT = pt;
+    entry->Eta = eta;
+    entry->Phi = phi;
+    entry->CtgTheta = ctgTheta;
+    entry->C = candidate->C;
+    entry->Mass = m;
+
+    particle = static_cast<Candidate *>(candidate->GetCandidates()->At(0));
+    //const TLorentzVector &initialPosition = particle->Position;
+    const TLorentzVector &initialPosition = candidate->InitialPosition;
+
+    entry->X = initialPosition.X();
+    entry->Y = initialPosition.Y();
+    entry->Z = initialPosition.Z();
+    entry->T = initialPosition.T() * 1.0E-3 / c_light;
+    entry->ErrorT = candidate-> ErrorT * 1.0E-3 / c_light;
+
+    entry->VertexIndex = candidate->ClusterIndex;
+
+    entry->Eem = candidate->Eem;
+    entry->Ehad = candidate->Ehad;
+    entry->Etrk = candidate->Etrk;
+    entry->Edges[0] = candidate->Edges[0];
+    entry->Edges[1] = candidate->Edges[1];
+    entry->Edges[2] = candidate->Edges[2];
+    entry->Edges[3] = candidate->Edges[3];
+
+    //entry->T = position.T() * 1.0E-3 / c_light;
+    entry->NTimeHits = candidate->NTimeHits;
+
+    FillParticles(candidate, &entry->Particles);
+
   }
 }
@@ -687,4 +840,7 @@
     entry->NCharged = candidate->NCharged;
     entry->NNeutrals = candidate->NNeutrals;
+
+    entry->NeutralEnergyFraction = candidate->NeutralEnergyFraction;
+    entry->ChargedEnergyFraction = candidate->ChargedEnergyFraction;
     entry->Beta = candidate->Beta;
     entry->BetaStar = candidate->BetaStar;
Index: modules/TreeWriter.h
===================================================================
--- modules/TreeWriter.h	(revision a5af1df1cf2ca5a488fc610ab546c762b7cdb5f2)
+++ modules/TreeWriter.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -56,4 +56,5 @@
   void ProcessTracks(ExRootTreeBranch *branch, TObjArray *array);
   void ProcessTowers(ExRootTreeBranch *branch, TObjArray *array);
+  void ProcessParticleFlowCandidates(ExRootTreeBranch *branch, TObjArray *array);
   void ProcessPhotons(ExRootTreeBranch *branch, TObjArray *array);
   void ProcessElectrons(ExRootTreeBranch *branch, TObjArray *array);
@@ -79,5 +80,5 @@
 #endif
 
-  ClassDef(TreeWriter, 1)
+  ClassDef(TreeWriter, 2)
 };
 
Index: modules/TruthVertexFinder.cc
===================================================================
--- modules/TruthVertexFinder.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/TruthVertexFinder.cc	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,158 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** \class TruthVertexFinder
+ *
+ *  Merges particles from pile-up sample into event
+ *
+ *  \author M. Selvaggi - UCL, Louvain-la-Neuve
+ *
+ */
+
+#include "modules/TruthVertexFinder.h"
+
+#include "classes/DelphesClasses.h"
+#include "classes/DelphesFactory.h"
+#include "classes/DelphesPileUpReader.h"
+#include "classes/DelphesTF2.h"
+
+#include "ExRootAnalysis/ExRootClassifier.h"
+#include "ExRootAnalysis/ExRootFilter.h"
+#include "ExRootAnalysis/ExRootResult.h"
+
+#include "TDatabasePDG.h"
+#include "TFormula.h"
+#include "TLorentzVector.h"
+#include "TMath.h"
+#include "TObjArray.h"
+#include "TRandom3.h"
+#include "TString.h"
+
+#include <algorithm>
+#include <iostream>
+#include <sstream>
+#include <stdexcept>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+
+TruthVertexFinder::TruthVertexFinder() :
+fItInputArray(0), fItOutputArray(0)
+{
+}
+
+//------------------------------------------------------------------------------
+
+TruthVertexFinder::~TruthVertexFinder()
+{
+}
+
+//------------------------------------------------------------------------------
+
+void TruthVertexFinder::Init()
+{
+
+  fResolution = GetDouble("Resolution", 1E-06); // resolution in meters
+  // import input array
+  fInputArray = ImportArray(GetString("InputArray", "Delphes/stableParticles"));
+  fItInputArray = fInputArray->MakeIterator();
+
+  // create output arrays
+  fVertexOutputArray = ExportArray(GetString("VertexOutputArray", "vertices"));
+  //fItOutputArray = fVertexOutputArray->MakeIterator();
+}
+
+//------------------------------------------------------------------------------
+
+void TruthVertexFinder::Finish()
+{
+  if(fItInputArray) delete fItInputArray;
+  if(fItOutputArray) delete fItOutputArray;
+}
+
+//------------------------------------------------------------------------------
+
+void TruthVertexFinder::Process()
+{
+  Int_t nvtx = -1;
+  Float_t pt;
+  Candidate *candidate, *vertex;
+  DelphesFactory *factory;
+
+
+  fItInputArray->Reset();
+
+  factory = GetFactory();
+  vertex = factory->NewCandidate();
+
+  TLorentzVector vertexPosition(0., 0., 0., 0.);
+
+  nvtx=0;
+  while((candidate = static_cast<Candidate *>(fItInputArray->Next())))
+  {
+
+     const TLorentzVector &candidatePosition = candidate->Position;
+     const TLorentzVector &candidateMomentum = candidate->Momentum;
+
+     pt = candidateMomentum.Pt();
+     
+     // check whether vertex already included, if so add particle
+     Bool_t old_vertex=false;
+     fItOutputArray = fVertexOutputArray->MakeIterator();
+     fItOutputArray->Reset();
+     while((vertex = static_cast<Candidate *>(fItOutputArray->Next())))
+     {
+        const TLorentzVector &vertexPosition = vertex->Position;
+        // check whether spatial difference is < 1 um, in that case assume it is the same vertex
+        if ( TMath::Abs((candidatePosition.P() - vertexPosition.P())) < fResolution*1.E3)
+        {
+           old_vertex=true;
+           vertex->AddCandidate(candidate);
+           if (TMath::Abs(candidate->Charge) > 0)
+           {
+              vertex->ClusterNDF += 1;
+              vertex->GenSumPT2 += pt*pt;
+           }
+        }
+     }
+
+     // else fill new vertex
+     if (!old_vertex)
+     {
+        vertex = factory->NewCandidate();
+        vertex->Position = candidatePosition;
+        vertex->ClusterIndex = nvtx;
+
+        if (TMath::Abs(candidate->Charge) > 0)
+        {
+           vertex->ClusterNDF = 1;
+           vertex->GenSumPT2 = pt*pt;
+        }
+        else
+        {
+           vertex->ClusterNDF = 0;
+           vertex->GenSumPT2 = 0.;
+        }
+        fVertexOutputArray->Add(vertex);
+        nvtx++;
+      }
+   }
+}
+
+//------------------------------------------------------------------------------
Index: modules/TruthVertexFinder.h
===================================================================
--- modules/TruthVertexFinder.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
+++ modules/TruthVertexFinder.h	(revision d612deca94f89952da103f30d46e21c02039b8bc)
@@ -0,0 +1,57 @@
+/*
+ *  Delphes: a framework for fast simulation of a generic collider experiment
+ *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef TruthVertexFinder_h
+#define TruthVertexFinder_h
+
+/** \class TruthVertexFinder
+ *
+ *  Produces list of MC truth vertices
+ *
+ *  \author M. Selvaggi - CERN
+ *
+ */
+
+#include "classes/DelphesModule.h"
+
+class TObjArray;
+
+class TruthVertexFinder: public DelphesModule
+{
+public:
+  TruthVertexFinder();
+  ~TruthVertexFinder();
+
+  void Init();
+  void Process();
+  void Finish();
+
+private:
+
+  Double_t fResolution; //!
+
+  TIterator *fItInputArray; //!
+  TIterator *fItOutputArray; //!
+
+  const TObjArray *fInputArray; //!
+
+  TObjArray *fVertexOutputArray; //!
+  ClassDef(TruthVertexFinder, 1)
+};
+
+#endif
